=== modified file 'NEWS'
--- NEWS	2010-01-17 15:07:39 +0000
+++ NEWS	2010-01-17 20:06:41 +0000
@@ -612,6 +612,9 @@
 * ``--parallel=fork`` is now compatible with --subunit.
   (Robert Collins, Vincent Ladeuil, #419776)
 
+* Reporting of failures shows test ids not descriptions and thus shows
+  parameterised tests correctly. (Robert Collins)
+
 * TestNotApplicable is now handled within the TestCase.run method rather
   than being looked for within ``ExtendedTestResult.addError``. This
   provides better handling with other ``TestResult`` objects, degrading to

=== modified file 'bzrlib/tests/__init__.py'
--- bzrlib/tests/__init__.py	2010-01-08 17:28:25 +0000
+++ bzrlib/tests/__init__.py	2010-01-17 20:06:41 +0000
@@ -237,6 +237,9 @@
                 '%d non-main threads were left active in the end.\n'
                 % (TestCase._active_threads - 1))
 
+    def getDescription(self, test):
+        return test.id()
+
     def _extractBenchmarkTime(self, testCase, details=None):
         """Add a benchmark time for the current test case."""
         if details and 'benchtime' in details:

=== modified file 'bzrlib/tests/test_selftest.py'
--- bzrlib/tests/test_selftest.py	2010-01-08 03:35:09 +0000
+++ bzrlib/tests/test_selftest.py	2010-01-17 21:48:39 +0000
@@ -1057,7 +1057,7 @@
             '(?sm)^bzr selftest.*$'
             '.*'
             '^======================================================================\n'
-            '^FAIL: unittest.FunctionTestCase \\(failing_test\\)\n'
+            '^FAIL: failing_test\n'
             '^----------------------------------------------------------------------\n'
             'Traceback \\(most recent call last\\):\n'
             '  .*' # File .*, line .*, in failing_test' - but maybe not from .pyc

